"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Plugin = void 0;

var _g = require("@antv/g");

var _manaSyringe = require("mana-syringe");

var _CanvasPickerPlugin = require("./CanvasPickerPlugin");

var _Circle = require("./Circle");

var _Ellipse = require("./Ellipse");

var _Line = require("./Line");

var _Polyline = require("./Polyline");

var _Path = require("./Path");

var _Rect = require("./Rect");

var _Polygon = require("./Polygon");

var containerModule = (0, _manaSyringe.Module)(function (register) {
  register({
    token: _CanvasPickerPlugin.PointInPathPickerFactory,
    useFactory: function useFactory(context) {
      return function (tagName) {
        if (tagName === _g.Shape.CIRCLE) {
          return _Circle.isPointInPath;
        } else if (tagName === _g.Shape.ELLIPSE) {
          return _Ellipse.isPointInPath;
        } else if (tagName === _g.Shape.RECT) {
          return _Rect.isPointInPath;
        } else if (tagName === _g.Shape.LINE) {
          return _Line.isPointInPath;
        } else if (tagName === _g.Shape.POLYLINE) {
          return _Polyline.isPointInPath;
        } else if (tagName === _g.Shape.POLYGON) {
          return _Polygon.isPointInPath;
        } else if (tagName === _g.Shape.PATH) {
          return _Path.isPointInPath;
        } else if (tagName === _g.Shape.IMAGE || tagName === _g.Shape.TEXT // tagName === Shape.GROUP
        ) {
          return function () {
            return true;
          };
        }

        return null;
      };
    }
  });
  register(_CanvasPickerPlugin.CanvasPickerPlugin);
});

var Plugin =
/** @class */
function () {
  function Plugin() {}

  Plugin.prototype.init = function (container) {
    container.load(containerModule, true);
  };

  Plugin.prototype.destroy = function (container) {
    container.unload(containerModule);
  };

  return Plugin;
}();

exports.Plugin = Plugin;